/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include <time.h>

#include <stdio.h>
#include <stdlib.h>

extern CYBLE_GAPP_DISC_MODE_INFO_T cyBle_discoveryModeInfo;
#define advPayload (cyBle_discoveryModeInfo.advData->advData)

CYBLE_CONN_HANDLE_T connHandle;
CYBLE_GATT_HANDLE_VALUE_PAIR_T ledHandle;

uint8 collectedData[4];
uint8 isNotify = 0;
uint8 updateIsNotifyCCCDAttr = 0;

uint8 bleConnected = 0;



void bleStack(uint32 event, void *eventParam){
    
    CYBLE_GATTS_WRITE_REQ_PARAM_T *wrReq;
    
    switch(event){
     
        case CYBLE_EVT_STACK_ON:
            CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);

        case CYBLE_EVT_GAP_DEVICE_CONNECTED:
            //CyBle_GappStopAdvertisement(); 
            break;
        case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
            CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
            break;
        case CYBLE_EVT_GAPP_ADVERTISEMENT_START_STOP:
             if(CyBle_GetState() == CYBLE_STATE_DISCONNECTED){
                 CyBle_GappStartAdvertisement(CYBLE_SCANNING_FAST);
            }
            break;
        case CYBLE_EVT_GATT_CONNECT_IND:
          
            bleConnected = 1;
            CyBle_GappStopAdvertisement();
            break;
        case CYBLE_EVT_GATT_DISCONNECT_IND:
        
            isNotify = 0;
            bleConnected = 0;
            
            updateIsNotifyCCCDAttr = 1;
            // write function to update notification CCCD
           break;
        case CYBLE_EVT_GATTS_WRITE_REQ:
            wrReq = (CYBLE_GATTS_WRITE_REQ_PARAM_T *)eventParam; //CYBLE_DAC_SERVICE_VOLT_VOLTCCCD_DESC_HANDLE
           
            if(wrReq->handleValPair.attrHandle == CYBLE_RVAC_SENSOR_SENSORCCCD_DESC_HANDLE){
               // CyBle_GattsWriteAttributeValue( &wrReq->handleValPair, 0, &connHandle, CYBLE_GATT_DB_LOCALLY_INITIATED);
                isNotify = wrReq->handleValPair.value.val[0];
                
                updateIsNotifyCCCDAttr = 1;
            }

            CyBle_GattsWriteRsp(cyBle_connHandle);
            
            break; 
        
     default:
        break;
    }
    
}

void SendDataNotify(uint8 *data, uint8 len){
    CYBLE_GATTS_HANDLE_VALUE_NTF_T notiHandle;
    

     notiHandle.attrHandle = CYBLE_RVAC_SENSOR_CHAR_HANDLE;
     notiHandle.value.val = data;
     notiHandle.value.len = len;
        
        CyBle_GattsNotification(cyBle_connHandle, &notiHandle);

}

void updateNotificationCCCD(void){
    CYBLE_GATT_HANDLE_VALUE_PAIR_T sensorNotCCCDHandle;
    
    uint8 sensorCCCDVal[2];
    
    if(updateIsNotifyCCCDAttr == 1){
        
     updateIsNotifyCCCDAttr = 0;
        sensorCCCDVal[0] = isNotify;
        sensorCCCDVal[1] = 0x00;
        
        sensorNotCCCDHandle.attrHandle = CYBLE_RVAC_SENSOR_SENSORCCCD_DESC_HANDLE;
        sensorNotCCCDHandle.value.val = sensorCCCDVal;
        sensorNotCCCDHandle.value.len = 2;
        
        CyBle_GattsWriteAttributeValue(&sensorNotCCCDHandle, 0, &cyBle_connHandle, CYBLE_GATT_DB_LOCALLY_INITIATED);
        CyBle_ProcessEvents();
    }
}

void dataFromPhone(){
    
}

uint8 randomNum(){
 
    return (uint8) (rand()%15)+1;
}

int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */
    
    
    
    CyBle_Start(bleStack);
    
    UART_1_Start();

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    srand(time(0));
    for(;;)
    {
         CyBle_ProcessEvents();
        /* Place your application code here. */
        
        collectedData[0] = randomNum();
        collectedData[1] = randomNum();
        collectedData[2] = randomNum();
        collectedData[3] = randomNum();
        
        advPayload[16] = collectedData[0];
        advPayload[17] = collectedData[1];
        advPayload[18] = collectedData[2];
        advPayload[19] = collectedData[3];
        

       if(bleConnected == 1){

        //updateNotificationCCCD();
        if(isNotify == 1){
            SendDataNotify(collectedData, 4);
        }
    }
        

        CyBle_GapUpdateAdvData(cyBle_discoveryModeInfo.advData, cyBle_discoveryModeInfo.scanRspData); //Update data in Advertisment Packet 
      
       
        
       
    }
}

/* [] END OF FILE */
